/*
 * Copyright 2008-2009 the T2 Project ant the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.t2framework.lucy.aop;

import java.util.List;

import org.t2framework.commons.aop.spi.Interceptor;
import org.t2framework.commons.meta.MethodDesc;

/**
 * {@link InterceptorDesc} is a temporal descriptor class for
 * {@link Interceptor}.This implemented class is used internally for aop
 * package.
 * 
 * @author shot
 * 
 */
public interface InterceptorDesc {

	/**
	 * Get target {@link MethodDesc}.
	 * 
	 * @return
	 */
	MethodDesc getMethodDesc();

	/**
	 * Get all {@link Interceptor}.
	 * 
	 * @return
	 */
	List<Interceptor> getInterceptors();
}
