/*
 * Copyright 2008-2009 the T2 Project ant the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.t2framework.lucy.aop.config;

import org.t2framework.commons.aop.spi.Aspect;
import org.t2framework.commons.aop.spi.Pointcut;
import org.t2framework.commons.meta.Config;
import org.t2framework.commons.meta.ExpressionAware;

/**
 * AnnotationDesc is a specialized configuration meta class for Aspect.
 * 
 * @author shot
 * 
 */
public interface AspectConfig extends Config, ExpressionAware {

	/**
	 * 
	 * {@.en Set {@link Pointcut}.}
	 * 
	 * <br />
	 * 
	 * {@.ja }
	 * 
	 * @param pointcut
	 */
	void setPointcut(Pointcut pointcut);

	/**
	 * 
	 * {@.en Get {@link Pointcut}.}
	 * 
	 * <br />
	 * 
	 * {@.ja }
	 * 
	 * @return
	 */
	Pointcut getPointcut();

	/**
	 * 
	 * {@.en Get enhance target class.}
	 * 
	 * <br />
	 * 
	 * {@.ja }
	 * 
	 * @return
	 */
	Class<?> getTargetClass();

	/**
	 * 
	 * {@.en Set enhance target class.}
	 * 
	 * <br />
	 * 
	 * {@.ja }
	 * 
	 * @param targetClass
	 */
	void setTargetClass(Class<?> targetClass);

	/**
	 * 
	 * {@.en Create {@link Aspect}.}
	 * 
	 * <br />
	 * 
	 * {@.ja }
	 * 
	 * @return
	 */
	Aspect createAspect();
}
