/*
 * Copyright 2008-2009 the T2 Project ant the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.t2framework.lucy.aop.impl;

import java.util.List;

import org.t2framework.commons.aop.spi.Interceptor;
import org.t2framework.commons.meta.MethodDesc;
import org.t2framework.commons.util.Assertion;
import org.t2framework.lucy.aop.InterceptorDesc;

public class InterceptorDescImpl implements InterceptorDesc {

	protected MethodDesc methodDesc;

	protected List<Interceptor> interceptors;

	public InterceptorDescImpl(MethodDesc method, List<Interceptor> interceptors) {
		Assertion.notNull(method);
		Assertion.notNull(interceptors);
		this.methodDesc = method;
		this.interceptors = interceptors;
	}

	@Override
	public List<Interceptor> getInterceptors() {
		return interceptors;
	}

	@Override
	public MethodDesc getMethodDesc() {
		return methodDesc;
	}
}
