/*
 * Copyright 2008-2009 the T2 Project ant the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.t2framework.lucy.aop.javassist;

import java.util.Map;

/**
 * 
 * {@.en Method template for weaving.}
 * 
 * <br />
 * 
 * {@.ja }
 * 
 * @author shot
 * 
 */
public interface MethodTemplate {

	String parse(Map<String, String> parameters);

	MethodTemplate defaultSuperMethod = MethodTemplateFactory
			.createMethodTemplate(MethodTemplate.class, "supermethod.template");

	MethodTemplate defaultAbstractMethod = MethodTemplateFactory
			.createMethodTemplate(MethodTemplate.class,
					"abstractmethod.template");

	MethodTemplate defaultMethod = MethodTemplateFactory.createMethodTemplate(
			MethodTemplate.class, "method.template");
}
