/*
 * Copyright 2008-2009 the T2 Project ant the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.t2framework.lucy.aop.module;

import org.t2framework.commons.aop.AopEngine;
import org.t2framework.commons.meta.spi.AnnotationConfigSupport;
import org.t2framework.lucy.aop.config.stax.AspectTagHandler;
import org.t2framework.lucy.config.stax.XmlEventHandler;
import org.t2framework.lucy.module.LucyAopModule;

public abstract class AbstractLucyAopModule implements LucyAopModule {

	protected static AspectTagHandler handler = new AspectTagHandler();

	@Override
	public XmlEventHandler getAspectTagHandler() {
		return handler;
	}

	@SuppressWarnings("unchecked")
	@Override
	public <S> S getService(Class<? super S> serviceClass) {
		if (XmlEventHandler.class.isAssignableFrom(serviceClass)) {
			return (S) getAspectTagHandler();
		} else if (serviceClass == getAspectBehaviorClass()) {
			return (S) getAspectBehaviorClass();
		} else if (AnnotationConfigSupport.class.isAssignableFrom(serviceClass)) {
			return (S) getAnnotationConfigSupport();
		} else if (AopEngine.class.isAssignableFrom(serviceClass)) {
			return (S) getAopEngine();
		}
		return null;
	}

}
