/*
 * Copyright 2008-2009 the T2 Project ant the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.t2framework.lucy.behavior;

import org.t2framework.commons.annotation.ConfigurationTarget;
import org.t2framework.commons.annotation.core.Component;
import org.t2framework.commons.meta.BeanDesc;
import org.t2framework.commons.meta.ClassDesc;
import org.t2framework.commons.meta.Config;
import org.t2framework.lucy.Lifecycle;
import org.t2framework.lucy.Lucy;
import org.t2framework.lucy.spi.Behavior;

/**
 * Component behavior.
 * 
 * @author shot
 */
@ConfigurationTarget(Component.class)
public class ComponentBehavior implements Behavior {

	public ComponentBehavior(BeanDesc<?> beanDesc, ClassDesc<?> classDesc,
			Config config) {
	}

	@Override
	public <T> void destroy() {
	}

	@Override
	public <T> void init() {
	}

	@Override
	public <T> T execute(T t, Lucy lucy) {
		return t;
	}

	@Override
	public Lifecycle getLifecycle() {
		return Lifecycle.CLASS_LOADING;
	}

	@Override
	public boolean isApplied(Lifecycle current) {
		return true;
	}
}
