/*
 * Copyright 2008-2009 the T2 Project ant the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.t2framework.lucy.behavior;

import org.t2framework.commons.annotation.ConfigurationTarget;
import org.t2framework.commons.annotation.composite.PrototypeScope;
import org.t2framework.commons.annotation.core.Prototype;
import org.t2framework.commons.meta.BeanDesc;
import org.t2framework.commons.meta.ClassDesc;
import org.t2framework.commons.meta.Config;
import org.t2framework.lucy.Lucy;
import org.t2framework.lucy.config.meta.impl.PrototypeInstanceConfig;

/**
 * 
 * {@.en PrototypeBehavior creates instance every time when it's called.}
 * 
 * <br />
 * 
 * {@.ja }
 * 
 * @author shot
 * 
 */
@ConfigurationTarget( { PrototypeScope.class, Prototype.class,
		PrototypeInstanceConfig.class })
public class PrototypeBehavior extends AbstractComponentCreationBehavior {

	public PrototypeBehavior(BeanDesc<?> beanDesc, ClassDesc<?> classDesc,
			Config cd) {
		super(beanDesc, classDesc, cd);
	}

	@SuppressWarnings("unchecked")
	@Override
	protected <T> T handleComponentCreation(T t, Lucy lucy,
			BeanDesc<Object> beanDesc) {
		if (beanDesc.isSingleton() == false && beanDesc.getComponent() != null) {
			return (T) beanDesc.getComponent();
		} else {
			return getInjector().inject(t, lucy);
		}
	}

}
