/*
 * Copyright 2008-2009 the T2 Project ant the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.t2framework.lucy.config.meta.impl;

import org.t2framework.commons.Constants;
import org.t2framework.lucy.config.meta.InjectConfig;

/**
 * 
 * {@.en A base class for inject tag configuration.}
 * 
 * <br />
 * 
 * {@.ja }
 * 
 * @author shot
 * 
 */
public abstract class AbstractInjectConfig extends AbstractOuterConfig
		implements InjectConfig {

	protected Class<?>[] parameterTypes = Constants.EMPTY_CLASS_ARRAY;

	protected boolean autoinjected = false;

	public AbstractInjectConfig() {
		this(false);
	}

	public AbstractInjectConfig(boolean autoinjected) {
		super(InjectConfig.class);
		this.autoinjected = autoinjected;
	}

	@Override
	public Class<?>[] getParameterTypes() {
		return parameterTypes;
	}

	@Override
	public void setParameterTypes(Class<?>[] paramTypes) {
		this.parameterTypes = paramTypes;
	}

	public boolean isAutoinjected() {
		return autoinjected;
	}

}
