/*
 * Copyright 2008-2009 the T2 Project ant the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.t2framework.lucy.config.stax;

import org.t2framework.commons.module.Modules;

/**
 * Implementation event handler rule for lucy configuration.
 * 
 * @author shot
 * 
 */
public class LucyConfigTagHandlerRule extends XmlEventHandlerRule {

	@SuppressWarnings("deprecation")
	public LucyConfigTagHandlerRule() {
		addHandler("lucy-config", new LucyConfigTagHandler());
		addHandler("include", new IncludeTagHandler());
		addHandler("component", new ComponentTagHandler());
		addHandler("components", new ComponentsTagHandler());
		addHandler("inject", new InjectTagHandler());
		addHandler("init", new InitTagHandler());
		addHandler("destroy", new DestroyTagHandler());
		addHandler("properties", new PropertiesTagHandler());
		setupExternalTagHandler();
	}

	protected void setupExternalTagHandler() {
		XmlEventHandler handler = Modules.getService(XmlEventHandler.class);
		if (handler != null) {
			addHandler("aspect", handler);
		}
	}
}
