/*
 * Copyright 2008-2009 the T2 Project ant the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.t2framework.lucy.config.stax;

import javax.xml.stream.XMLResolver;
import javax.xml.stream.XMLStreamException;

import org.t2framework.commons.util.ResourceUtil;

/**
 * The resolver class for lucy-config.dtd.The resolve entity should not do
 * remote access for lucy-config.dtd, instead of remote access, just returns one
 * which we keep in jar.
 * 
 * @author shot
 * 
 */
public class LucyXmlResolver implements XMLResolver {

	public static final String PUBLIC_ID = "-//LUCY//DTD LUCY//EN";

	public static final String DTD_PATH = "org/t2framework/lucy/config/stax/lucy-config.dtd";

	public LucyXmlResolver() {
	}

	@Override
	public Object resolveEntity(String publicID, String systemID,
			String baseURI, String namespace) throws XMLStreamException {
		if (PUBLIC_ID.equals(publicID)) {
			return ResourceUtil.getResourceAsStream(DTD_PATH);
		}
		return null;
	}

}
