/*
 * Copyright 2008-2009 the T2 Project ant the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.t2framework.lucy.config.stax;

/**
 * 
 * {@.en Tag handler for StAX. Implementation of {@link XmlEventHandler} should
 * be created by each tag.}
 * 
 * <br />
 * 
 * {@.ja StAXを処理するためのタグハンドラです．}
 * 
 * @author shot
 * 
 */
public interface XmlEventHandler {

	/**
	 * Hook point for starting tag.
	 * 
	 * @param context
	 * @param attributes
	 */
	void start(XmlEventContext context, Attributes attributes);

	/**
	 * Hook point for ending tag.
	 * 
	 * @param context
	 * @param body
	 */
	void end(XmlEventContext context, String body);
}
