/*
 * Copyright 2008-2009 the T2 Project ant the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.t2framework.lucy.config.stax;

import java.util.Map;

import org.t2framework.commons.util.CollectionsUtil;

/**
 * The mapping class between a xml tag to a {@link XmlEventHandler}.
 * 
 * @author shot
 * 
 */
public class XmlEventHandlerRule {

	protected Map<String, XmlEventHandler> map = CollectionsUtil.newHashMap();

	public void addHandler(String name, XmlEventHandler handler) {
		map.put(name, handler);
	}

	public XmlEventHandler getHandler(String name) {
		return map.get(name);
	}
}
