/*
 * Copyright 2008-2009 the T2 Project ant the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.t2framework.lucy.exception;

/**
 * 
 * {@.en Runtime exception which occurs when resolving constructor arguments
 * failed.It could be done by cyclic reference.}
 * 
 * <br />
 * 
 * {@.ja コンストラクタの引数解決が上手くいかない場合のランタイム例外です. 循環参照による失敗の可能性もあります.}
 * 
 * @author shot
 * 
 */
public class ConstrucorInjectionFailureException extends
		LucyBaseRuntimeException {

	/**
	 * 
	 * {@.en }
	 * 
	 * <br />
	 * 
	 * {@.ja シリアルバージョンUIDです.}
	 * 
	 */
	private static final long serialVersionUID = 4118352019598922344L;

	public ConstrucorInjectionFailureException(String classname) {
		super("ELucyCore0011", classname);
	}
}
