/*
 * Copyright 2008-2009 the T2 Project ant the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.t2framework.lucy.exception;

import org.t2framework.commons.util.Assertion;

/**
 * Exception for the target method is not found.
 * 
 * @author shot
 */
public class MethodNotFoundException extends LucyBaseRuntimeException {

	private static final long serialVersionUID = 1444059107210701494L;

	protected final Class<?> clazz;

	protected final String methodName;

	protected int lineNo;

	public MethodNotFoundException(Class<?> clazz, String methodName,
			int lineNo, int columnNo) {
		super("ELucyCore0006", clazz.getName(), methodName, lineNo, columnNo);
		this.clazz = Assertion.notNull(clazz);
		this.methodName = Assertion.notNull(methodName);
		this.lineNo = Assertion.notNull(lineNo);
	}
}
