/*
 * Copyright 2008-2009 the T2 Project ant the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.t2framework.lucy.inject;

import org.t2framework.lucy.Lucy;
import org.t2framework.lucy.exception.CyclicReferenceRuntimeException;

/**
 * 
 * {@.en {@link Injector} injects component using {@link Lucy} to the
 * instance.}
 * 
 * <br />
 * 
 * {@.ja {@link Injector}はコンポーネントへのインジェクトを実現します.}
 * 
 * @author shot
 * 
 */
public interface Injector {

	/**
	 * 
	 * {@.en Inject component from {@link Lucy} to the instance representing
	 * T.}
	 * 
	 * <br />
	 * 
	 * {@.ja コンポーネントTに対してインジェクトを行います.}
	 * 
	 * @param <T>
	 * @param t
	 * @param lucy
	 * @return
	 * @throws CyclicReferenceRuntimeException
	 */
	<T> T inject(T t, Lucy lucy) throws CyclicReferenceRuntimeException;
}
