/*
 * Copyright 2008-2009 the T2 Project ant the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.t2framework.lucy.module;

import org.t2framework.commons.el.spi.ExpressionFactory;
import org.t2framework.commons.module.Module;
import org.t2framework.lucy.el.AbstractExpressionFactory;

/**
 * 
 * {@.en }
 * 
 * <br />
 * 
 * {@.ja Lucyが稼動するためのコアモジュールを提供するモジュールインタフェースです.}
 * 
 * @author shot
 * 
 */
public interface LucyCoreModule extends Module {

	/**
	 * 
	 * {@.en Return ExpressionFactory.It should be singleton instance.}
	 * 
	 * <br />
	 * 
	 * {@.ja {@link ExpressionFactory}を返します.}
	 * 
	 * @param <C>
	 * @return
	 */
	AbstractExpressionFactory getExpressionFactory();
}
