/*
 * Copyright 2008-2009 the T2 Project ant the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.t2framework.lucy.spi;

import org.t2framework.commons.Disposable;
import org.t2framework.lucy.ConfigBindResult;

/**
 * ComponentBuilder is a SPI interface that builds a component using behaviors
 * from ConfigBindResult.
 * 
 * @author shot
 */
public interface ComponentBuilder extends Disposable {

	/**
	 * Build component.
	 * 
	 * @param <T>
	 * @param t
	 * @param result
	 * @return
	 */
	<T> T build(T t, final ConfigBindResult result);

	/**
	 * Load {@link LucyConfiguration}.
	 * 
	 * @param conf
	 * @return
	 */
	ComponentBuilder loadConfiguration(final LucyConfiguration conf);
}
